#  2008-10-08
# Copyright (C) 2008 Alban Ramette
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.


qfingerprinting=function(D){
cat("qfingerprinting function v.1.3. by A. Ramette\n")
cat("D contains the samples-by-OTUs table with the last 2 columns corresponding\n")
cat("to the Dilution_order (e.g. 1..6), Sample_order (e.g. 1..n).  \n")
cat("D must be a complete table containing all replicates and all dilution levels\n")
cat("(i.e. missing replicates or dilution levels have to be present as a series of 0.\n")


ANS<-readline("Continue? (y/n)....... ")
if(ANS=="y"){
#################################################
qfingerprint=function(D){
D=D[order(D[,ncol(D)]),] #ordering the replicates
D1=D
#conversion to 01
D1[D1!=0]<-1
D1[,ncol(D1)]=D[,ncol(D)]   #to rewrite the last column

AL2=function(M){############
          RFI_3_cons=function(M){
          L=ncol(M)-1	#number of bins=nber of columns. Last column = rep #
          CONS=rep(0,L)	#vector with the CONSensus (average of >= 2 present)
          for (c in 1:L) {
          if(M[1,c]!=0 & M[2,c]!=0 & M[3,c]==0) CONS[c]=mean(M[1:2,c])
          if(M[1,c]!=0 & M[3,c]!=0 & M[2,c]==0) CONS[c]=mean(M[c(1,3),c])
          if(M[2,c]!=0 & M[3,c]!=0 & M[1,c]==0) CONS[c]=mean(M[c(2:3),c])
          if(M[1,c]!=0 & M[2,c]!=0 & M[3,c]!=0) CONS[c]=mean(M[1:3,c])
          }
          CONS
          } 
          #ordered list of sample names
          U=sort(unique(M[,ncol(M)]))
          
          #how many samples
          Nsample=length(U)
          Res=matrix(NA,Nsample,ncol(M))	#matrix of results
          
          for (i in 1:Nsample) {
            Mtemp=M[M[,ncol(M)]==U[i],]
            Res[i,]=c(U[i],RFI_3_cons(Mtemp))	
          }#end of for i
             
          rownames(Res)=Res[,1]
          Res=Res[,-1]
          colnames(Res)=colnames(M[,1:(ncol(M)-1)])
          return(Res)
}## end of AL2 #########################


D2=AL2(D1)   #D2 contains the 01 data (1 means 2/3 satisfied
rm(AL2)
   Res1=matrix(0,1,ncol(D2))
   colnames(Res1)=colnames(D2)
    rownames(Res1)="log_abund"

#checking for the continuity of the vector   
D3=apply(D2,2,function(x) paste(x,collapse="")) #conversion to text
for (i in 1:length(Res1)) {
    if(length(grep("^10",D3[i],value=FALSE))==1)     Res1[i]=1
    if(length(grep("^110",D3[i],value=FALSE))==1)    Res1[i]=2
    if(length(grep("^1110",D3[i],value=FALSE))==1)   Res1[i]=3
    if(length(grep("^11110",D3[i],value=FALSE))==1)  Res1[i]=4
    if(length(grep("^111110",D3[i],value=FALSE))==1) Res1[i]=5
    if(length(grep("^1111110",D3[i],value=FALSE))==1)Res1[i]=6
    if(length(grep("^1111111",D3[i],value=FALSE))==1) Res1[i]=7

}#end for i
                   
return(Res1)

}   #end of the function
#####################
#### MAIN SCRIPT

#Select the last, order of the samples
Ordsample=as.numeric(D[,ncol(D)])
U=unique(Ordsample)
#preparing the result
Result=matrix(NA,length(unique(Ordsample)),ncol(D)-2)
rownames(Result)=unique(Ordsample)
colnames(Result)=colnames(D)[1:(ncol(D)-2)]

#subselecting the data
for (i in 1:length(U)) {
  Mtemp=D[D[,ncol(D)]==U[i],] #selecting the subsample
  Mtemp=Mtemp[,-ncol(Mtemp)]      #deleting the last columns (sample)
  Result[i,]=as.numeric(qfingerprint(Mtemp))
}#end of for i

Result=Result[,apply(Result,2,sum)!=0]
write.table(Result,"Out.txt",quote=FALSE)
cat("Done.\n")
return(Result)

}#end of ANS=yes

}#end of the main function



